unit Areg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, toreg, sysutils, dialogs;

type

  TRegAsk = class(TForm)
    OKBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    expire : integer;
  end;

var
  RegAsk: TRegAsk;

implementation
{$R *.DFM}


procedure TRegAsk.HelpBtnClick(Sender: TObject);
var   ToRegister: TToRegister;
 N : INTEGER;
begin
  ToRegister:= TToRegister.create(application);
  ToRegister.showmodal;
  N := ToRegister.RE;
  ToRegister.free;
  IF N <> IDCANCEL THEN
   begin
    expire := 0;
    CLOSE;
   end;
end;

procedure TRegAsk.FormCreate(Sender: TObject);
begin
label1.caption := user + #13#13 + ver
+ #13#13'Unregister';

end;

procedure TRegAsk.FormShow(Sender: TObject);
begin
if expire > 1 then
label1.caption := label1.caption +  #13#13'Evaluation expires in ' + inttostr(expire) + ' days';
HELPBTN.SETFOCUS;
end;

procedure TRegAsk.OKBtnClick(Sender: TObject);
begin
if expire = 1 then
 Begin
  Showmessage('Product evaluation has been expired!'#13#13'Please register');
  halt;
 end;
end;

end.
