{.$define debug}
unit Toreg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, dialogs, SYSUTILS;

type
  TToRegister = class(TForm)
    Label1: TLabel;
    CancelBtn: TBitBtn;
    company: TEdit;
    version: TEdit;
    key: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure keyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    RE : INTEGER;
  end;


var
  ToRegister: TToRegister;
  User, ver : string[20];

  function make_password(user,id:string): string;
  function sum_str(s:string): word;
CONST
    VIVID : STRING = '1258';
implementation
uses inifiles;
{$R *.DFM}
const
      Hidden_code  = 'SECRET';
      Hidden_Digit = '1258';
      pref      = 'PD';
      valid_set : set of char = ['0'..'9','A'..'Z'];
      ln = 12;

function maskit(s,mask:string):string;
var i,f,n : byte;
begin
 f := 0;
 for i := 1 to length(s) do
  begin
    inc(f);
    if f > length(mask) then f := 1;
     n :=  byte(s[i]) xor byte(mask[f]);
     s[i]:= char(n);
  end;
maskit := s;
end;

function sum_str(s:string): word;
var i : byte;
    re : word;
begin
 re := 0;
 for i := 1 to length(s) do
   re := re + byte(s[I]);
sum_str := re;
end;


Function IntToStr(N : LongInt):String;
{$IFDEF WINDOWS}
BEGIN
IntToStr:= SYSUTILS.INTTOSTR(N);
{$ELSE}
  var S:string[11];
  begin
    Str(N, S);
    IntToStr := S;
{$ENDIF}
  end;


function randomit(frm, tto : byte): byte;
var n : integer;
begin
n := 0;
repeat
 n := random(tto);
until (n >= frm) and (char(n) in valid_set);
randomit := n;
end;


procedure make_vivid(user:string);
var i,n : byte;
    s2 : string;
    maskst : string[5];

function found(c:char):boolean;
 var m : byte;
begin
found := false;
 for m := 1 to length(vivid) do
   if vivid[m] = c then
     found := true;
end;

begin
s2 := Hidden_code;
maskst := inttostr(sum_str(user));
s2 := maskit(s2,maskst);
 for i := 1 to length(vivid) do
  begin
    n:= byte(s2[i]) - 65;
    if n > 7 then n:= n mod 7;
    if found(char(n + 50)) then
      repeat
        inc(n);
        if n > 7 then n:= n mod 7;
      until not found(char(n + 50));
    vivid[i] := char(n + 50);
  end;
end;

function make_password(user,id:string): string;
var i : byte;
  re : string;
Begin
  re:= pref;
  for i := 1 to ln - length(pref) do
    re := re + char(randomit(48,122));

  VIVID := Hidden_Digit;
{4 digit here, can be up to 12}
  make_vivid(user);

{check digits}
 
  re[byte(vivid[1]) - 48] := char(length(user) + 65);
  re[byte(vivid[2]) - 48] := char(length(ID) + 65);
  i := length(inttostr(sum_str(user) - sum_str(id)));
  re[byte(vivid[3]) - 48] := char(i + 48);
  i := length(inttostr(sum_str(user) - sum_str(vivid)));
  re[byte(vivid[4]) - 48] := char(i + 48);

  make_password := re;

end;

FUNCTION valid_password(PS,USER,ID:STRING):BOOLEAN;
VAR S : STRING;
BEGIN
 valid_password := false;
 S:= MAKE_PASSWORD(USER,ID);
 IF (S[BYTE(vivid[1])-48] = PS[BYTE(vivid[1])-48]) AND
    (S[BYTE(vivid[2])-48] = PS[BYTE(vivid[2])-48]) AND
    (S[BYTE(vivid[3])-48] = PS[BYTE(vivid[3])-48]) AND
    (S[BYTE(vivid[4])-48] = PS[BYTE(vivid[4])-48]) THEN
 valid_password := TRUE;
END;


procedure TToRegister.FormCreate(Sender: TObject);
begin
 version.text := ver;
 company.text := user;
end;

procedure TToRegister.OKBtnClick(Sender: TObject);
{$IFDEF DEBUG}
  var s: string;
      n: integer;
{$ENDIF}
begin
{$IFDEF DEBUG}
  s:= make_password(company.text,version.text);
  caption := s;
{$ENDIF}

user := company.text;
ver := version.text;

if valid_password(key.text,company.text,version.text) then
begin
  with TInifile.create('Registry.ini') do
   begin
{$ifdef debug}
    n:= sum_str(VIVID) + SUM_STR(USER) + SUM_STR(VER);
{$endif}
    WriteInteger('Registry',Application.title,sum_str(VIVID) + SUM_STR(USER) + SUM_STR(VER));
    Writestring('Registry','RegisterDate', DateToStr(date));
    Writestring('Registry','Username',company.text );
    free;
   end;
  SHOWMESSAGE('Thanks for registered');
  RE:= IDOK;
  close;
 end
else
 showmessage('Invalid key. Please re enter');

end;

procedure TToRegister.CancelBtnClick(Sender: TObject);
begin
 RE := 2;
 MODALRESULT := IDCANCEL;
end;

procedure TToRegister.keyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
IF ( [ssAlt, ssCtrl] = SHIFT) THEN
 BEGIN
  KEY.TEXT := make_password(company.text,version.text);
 END;
end;

end.

